// * This code is licensed under:
// * JSlovo License, Version 1.0
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

/*
 * Application.java
 *
 * Created on March 17, 2005, 11:17 AM
 */

package jslovo.ui;


import java.awt.*;
import jslovo.util.*;
import javax.swing.UIManager.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 *
 * @author  chekanov
 */
public class Application extends JFrame {


    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static JMenuItem aboutMenuItem;
    private static JMenuItem contentsMenuItem;
    private JMenuItem keyboardMenuItem;
    private JMenuItem dbmakerMenuItem;
    private JMenuItem fontMenuItem;
    private JMenuItem foreMenuItem;
    private JMenuItem backMenuItem;
    private static JMenuItem exitMenuItem;
    private JMenu fileMenu;
    private JMenu helpMenu;
    private JMenu toolsMenu; 
    private JMenu optionsMenu;
    private JMenu LookFeel;
    private JMenu LangMenu;
    private static MenuListener   mListener = new MListener();

    private PanelSelectDic  jPanel2;
    private JPanel jPanelStatus;
    private JSplitPane jSplitPane1;
    private JSplitPane jSplitPane2;
    private JMenuBar menuBar;
    private JMenuItem pasteMenuItem;
    private static JMenuItem saveAsMenuItem;
    private JTabbedPane jTabs; 
    private JLabel statusBar;
    private MemoryMonitor memMon;
    private PanelAnswer jAnswer;
    private PanelHelper jHelp;
    private PanelAnswerLinks jAnswerLinks;
    public ButtonGroup group;
    public JRadioButton bexact;
    public JRadioButton blike;
    private Timer timer1; // for keyboard 
    private Timer timer0; // to update GUI 
    private static int  StyleTMP=0;
    private int wGUI;

    private static String tmpUnicodeChar="";
//    private JFileChooser fc; 
    public JRadioButtonMenuItem Sty0;
    public JRadioButtonMenuItem Sty1;
    public JRadioButtonMenuItem Sty2;
    public JRadioButtonMenuItem Sty3;
    public JRadioButtonMenuItem Sty4;
    public JRadioButtonMenuItem Sty5;

    public JRadioButtonMenuItem Lang0;
    public JRadioButtonMenuItem Lang1;

 
    StopWatch sw    = new StopWatch();


    /** Creates new form Application */
    public Application() {
        initComponents();

/*
        // listen this windows. if it's closed set to exect
      this.addWindowListener(new WindowAdapter()
     {
       public void windowClosing(WindowEvent e)
       {
       System.out.println("Debug: closed");
       }
       public void windowStateChanged(WindowEvent e)
       {
       System.out.println("WindowListener method called: windowStateChanged.");
       }
       public void windowLostFocus(WindowEvent e) {
       }
       public void windowIconified(WindowEvent e) {
        System.out.println("WindowListener method called: windowIconified.");
       }

        public void windowDeiconified(WindowEvent e) {
        System.out.println("WindowListener method called: windowDeiconified.");
         }

         public void windowActivated(WindowEvent e) {
        System.out.println("WindowListener method called: windowActivated.");
          }

         public void windowDeactivated(WindowEvent e) {
        System.out.println("WindowListener method called: windowDeactivated.");
         }

         public void windowGainedFocus(WindowEvent e) {
        System.out.println("WindowFocusListener method called: windowGainedFocus.");
         }


     });
*/


    }
   
 
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents


     // get GUI width 	    
    int wGUI=  Options.getIntOption("frame.width");
	    
    // set GUI style
    SetGuiStyle();
	  
    /*

      Font fnt = new Font("Arial", Font.BOLD, 14);
      Font fnt16 = new Font("Arial", Font.BOLD, 14);
      Font fnt12 = new Font("Arial", Font.BOLD, 12);

      // AWT
      UIManager.put("Menu.font",fnt16);
      UIManager.put("MenuBar.font",fnt16);
      UIManager.put("MenuItem.font",fnt16);
      UIManager.put("Button.font", fnt);
      UIManager.put("List.font", fnt);
      UIManager.put("Dialog.font", fnt);
      UIManager.put("ToggleButton.font",fnt);
      UIManager.put("Panel.font", fnt);
      UIManager.put("ComboBox.font", fnt);
      UIManager.put("RadioButtonMenuItem.font", fnt);
      UIManager.put("PopupMenu.font", fnt);
      UIManager.put("MenuItem.font", fnt);
      UIManager.put("ScrollPane.font", fnt);
      UIManager.put("RadioButton.font", fnt);
      UIManager.put("TabbedPane.font", fnt);
      UIManager.put("Table.font", fnt);
      UIManager.put("TableHeader.font",fnt12);
      UIManager.put("TextField.font", fnt);
      UIManager.put("TextPane.font",fnt);
      UIManager.put("TextDialog.font",fnt);
      UIManager.put("TextArea.font", fnt);
      UIManager.put("ToolBar.font", fnt);
      UIManager.put("ToolTip.font", fnt12);
      UIManager.put("OptionPane.font", fnt);
      */
     
      // define timer for pipe files
     timer1 = new Timer(200, taskUNICODE);
// define timer for updatting GUI
     timer0 = new Timer(400, taskUPDATE);
     timer0.setRepeats(true);
     timer0.start();


// set size 
     int w=Options.getIntOption( "frame.width" );
     int h=Options.getIntOption( "frame.height" );
// Get the system resolution
    Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
// make sure the dialog is not too big
    Dimension size = new Dimension(Math.min(w,res.width),
                        Math.min(h, res.height) );
     setSize(size);
  

     jPanel2 = new PanelSelectDic();
     new Thread2("make names of the databases and boot them");


     // check which one are active
     String activeDB =  Options.getOption("dictionary.active");
     String[] a = activeDB.split(";");

 for(int i=0;i<Global.dbbases.size();i++) {
                 Global.ActivateDic[i] = false;
                 boolean active=false;
                 for (int j = 0; j < a.length; j++) {
                    if (a[j].length() > 1) {
                       if (Global.dbbases.get(i).equals(a[j])) active=true;
                 }
                 }
                Global.ActivateDic[i] = active;
                // System.out.println(active);
      }






     jAnswer = new PanelAnswer();
     jAnswer.Style(); // set colors
   //  jAnswer.jArticle.setPreferredSize(new java.awt.Dimension(400, 300));
     jAnswerLinks = new PanelAnswerLinks();

     jHelp = new PanelHelper();


     jTabs = new JTabbedPane();
     jTabs.addTab(ResourceLoader.getCommand("panel.article"),jAnswer);
     jTabs.addTab(ResourceLoader.getCommand("panel.article.html"),jAnswerLinks);
     jTabs.addTab(ResourceLoader.getCommand("panel.article.help"),jHelp);

     int w1= (int)(0.6 * wGUI );
     jAnswer.setPreferredSize(new java.awt.Dimension(w1, 300));
     jAnswerLinks.setPreferredSize(new java.awt.Dimension(w1, 300));
     jHelp.setPreferredSize(new java.awt.Dimension(w1, 300));


     jTabs.setToolTipTextAt(0, ResourceLoader.getDisplay("tip.article"));
     jTabs.setToolTipTextAt(1, ResourceLoader.getDisplay("tip.article_html"));
     jTabs.setToolTipTextAt(2, ResourceLoader.getDisplay("tip.article_help"));
    // Register a change listener
     jTabs.addChangeListener(new ChangeListener() {
        public void stateChanged(ChangeEvent evt) {
            JTabbedPane pane = (JTabbedPane)evt.getSource();
            // Get current tab
            int sel = pane.getSelectedIndex();
            // statusBar.setText("Creating HTML links" );
          //   System.out.println(sel);
            if (sel == 1)   {
                 jAnswerLinks.jArticleLinks.setText(ResourceLoader.getDisplay("message.makinghtml")); 
                 new Thread1("Making HTML links");
            }

   
        }
    });



      // set the word
      jPanel2.SearchField.setText(Global.Word);


// create Hyperlink listener for article
      jAnswerLinks.jArticleLinks.addHyperlinkListener(new HyperlinkListener() {
      public void hyperlinkUpdate(HyperlinkEvent ev) {
          if (ev.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
             // System.out.println(ev.getDescription());
              // format this word  
              Global.Word=Format.formatLinks( ev.getDescription() );
              Global.Message=ResourceLoader.getDisplay("message.selected")+"  '"+Global.Word+"'";
              statusBar.setText(Global.Message);
       //    jPanel2.SearchField.setText(Global.Word);

          if (Global.Word.length()>0) {
          sw.start();
          if (Global.SelectSubstring==true) SetToExact(); 
          jHelp.Get();           // get answer
     //     System.out.println("Debug: Activate link:"+Global.Word); 
          sw.stop();
          Global.Message=ResourceLoader.getDisplay("message.dbtime")+"= "+Long.toString(sw.getTime())+ " ms";

          statusBar.setText(Global.Message);
          }
              jTabs.setSelectedIndex(2);
         }   }
    });





        group =new ButtonGroup();
        bexact = new JRadioButton(ResourceLoader.getCommand("menu.exactmatch"),true);
        blike = new JRadioButton(ResourceLoader.getCommand("menu.substring"),false);
        group.add(bexact);
        group.add(blike);
        bexact.addActionListener( Global.mainActionListener );
        blike.addActionListener( Global.mainActionListener ); 


       jSplitPane1 = new javax.swing.JSplitPane();








     jPanel2.SearchField.getDocument().addDocumentListener(new DocumentListener() {
     public void changedUpdate(DocumentEvent e) {
      //   System.out.println( SearchField.getText() );
        Global.Word=jPanel2.SearchField.getText().trim();

      }
     public void removeUpdate(DocumentEvent e) {
      // System.out.println( SearchField.getText() );
        Global.Word=jPanel2.SearchField.getText().trim();
      }
     public void insertUpdate(DocumentEvent e) {
      //  System.out.println( SearchField.getText() );
        Global.Word=jPanel2.SearchField.getText().trim();
     }  });



         // status bar
        statusBar = new JLabel(ResourceLoader.getDisplay("info.status") ); 
        memMon = new MemoryMonitor();
        memMon.setPreferredSize(new java.awt.Dimension(65, 18));
        memMon.setMinimumSize(new java.awt.Dimension(23, 10));
        jPanelStatus = new JPanel();
    //    jPanelStatus.setPreferredSize(new Dimension(700, 20));
        jPanelStatus.setLayout( new BorderLayout());
        jPanelStatus.setBorder(new javax.swing.border.EtchedBorder());
        jPanelStatus.add(statusBar,BorderLayout.WEST);
        jPanelStatus.add(memMon,BorderLayout.EAST);


        menuBar = new JMenuBar();
 //       fileMenu = new JMenu();

        fileMenu=buildFileMenu();
 
//        openMenuItem = new JMenuItem();
//        saveAsMenuItem = new JMenuItem();

        helpMenu = new JMenu();
        toolsMenu = new JMenu();
        optionsMenu = new JMenu();

// sett look at fill 
        LookFeel = new JMenu(ResourceLoader.getCommand("menu.look"));
        optionsMenu.add(LookFeel);
        ButtonGroup group = new ButtonGroup();
        Sty0 = new JRadioButtonMenuItem(Global.defa, false);
        Sty1 = new JRadioButtonMenuItem(Global.metal,false);
        Sty2 = new JRadioButtonMenuItem(Global.motif,true);
        Sty3 = new JRadioButtonMenuItem(Global.windows,false);
        SetButtonMenu();

        Sty0.setHorizontalTextPosition(JMenuItem.RIGHT);
        Sty1.setHorizontalTextPosition(JMenuItem.RIGHT);
        Sty2.setHorizontalTextPosition(JMenuItem.RIGHT);
        Sty3.setHorizontalTextPosition(JMenuItem.RIGHT);
       Sty0.addActionListener(new java.awt.event.ActionListener() {
       public void actionPerformed(ActionEvent e)
      { Global.Style=0; } });

      Sty1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      { Global.Style=1; } });

      Sty2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      { Global.Style=2; } });

      Sty3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e)
      { Global.Style=3; } });


        group.add(Sty0);
        group.add(Sty1);
        group.add(Sty2);
        group.add(Sty3);
        LookFeel.add(Sty0);
        LookFeel.add(Sty1);
        LookFeel.add(Sty2);
        LookFeel.add(Sty3);




// sett look at fill
        LangMenu = new JMenu( ResourceLoader.getCommand("menu.lang") );
        optionsMenu.add(LangMenu);
        ButtonGroup glang = new ButtonGroup();
        Lang0 = new JRadioButtonMenuItem(Global.LANG_en, true);
        Lang0.setHorizontalTextPosition(JMenuItem.RIGHT);
        Lang0.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e)
        { Global.LANGU="en"; 
           // localisation
           Options.setOption( "user.locale",Global.LANGU);
           ShowInfo(ResourceLoader.getDisplay("info.restart")); } });



        Lang1 = new JRadioButtonMenuItem(Global.LANG_ru,false);
        Lang1.setHorizontalTextPosition(JMenuItem.RIGHT);
        Lang1.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e)
        { Global.LANGU="ru";  
              Options.setOption( "user.locale",Global.LANGU);
              ShowInfo(ResourceLoader.getDisplay("info.restart")); } });

        SetButtonLocal(); // set now 


        glang.add(Lang0);
        glang.add(Lang1);
        LangMenu.add(Lang0);
        LangMenu.add(Lang1);




  //      contentsMenuItem = makeItem( "menu.help.docs", true ); 
  //      aboutMenuItem = makeItem( "menu.help.about", true );


        keyboardMenuItem = makeItem( "menu.tools.keyboard", true );
        dbmakerMenuItem = makeItem( "menu.tools.makedb", true );
        fontMenuItem = makeItem( "menu.options.fonts", true );
        foreMenuItem = makeItem( "menu.options.foreground", true );
        backMenuItem  = makeItem( "menu.options.background", true );


        menuBar.add(bexact);
        menuBar.add(blike);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("JSlovo");
        jSplitPane1.setMinimumSize(new java.awt.Dimension(4, 4));
        jSplitPane1.setOneTouchExpandable(true);

        int w2=(int)(0.3*wGUI); 
        jPanel2.setPreferredSize(new java.awt.Dimension(w2, 200));
        jPanel2.setMinimumSize(new java.awt.Dimension(70, 200));


// search
/*
        jPanel2.jSearchButton.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
        jTabs.setSelectedIndex(0);
        jAnswer.jArticle.setText("Searching for word = "+Global.Word+" .. wait!");
        new Thread3("Searching for a word");
        System.gc();
       } });

*/

        jSplitPane1.setLeftComponent(jPanel2);
        jSplitPane1.setDividerLocation(0.3);


        jSplitPane1.setRightComponent(jTabs);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);
        getContentPane().add(jPanelStatus, java.awt.BorderLayout.SOUTH);


        menuBar.add(new JSeparator());
        menuBar.add(fileMenu);


         toolsMenu.setText( ResourceLoader.getCommand("menu.tools") );

         toolsMenu.add(keyboardMenuItem);
         toolsMenu.add(dbmakerMenuItem);





         optionsMenu.setText(ResourceLoader.getCommand("menu.options"));
         optionsMenu.add(fontMenuItem); 
         optionsMenu.add(foreMenuItem);
         optionsMenu.add(backMenuItem);
         menuBar.add(optionsMenu);



/*

       backMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
         Color color = JColorChooser.showDialog(Application.this,
                       "Background Color",jAnswer.jArticle.getBackground());
         if (color != null) {
         Global.background_color="#"+Integer.toHexString( color.getRGB() & 0x00ffffff ); 
//         jAnswer.jArticle.setBackground(color);
         jAnswer.Style(); // set colors
         SearchResult();  // to reset the color 
         }
           jAnswer.jArticle.repaint();
           }
        });

*/


// react when one raw in the table is activated
ListSelectionModel rowSM = jPanel2.jDicSelect.getSelectionModel();
rowSM.addListSelectionListener(new ListSelectionListener() {
    public void valueChanged(ListSelectionEvent e) {
        //Ignore extra messages.
        if (e.getValueIsAdjusting()) return;

        ListSelectionModel lsm =
            (ListSelectionModel)e.getSource();
        if (lsm.isSelectionEmpty()) {
//            ...//no rows are selected
          statusBar.setText(  ResourceLoader.getDisplay("info.status") );
        } else {
            int selectedRow = lsm.getMinSelectionIndex();
//           ...//selectedRow is selected
             String sfile=(String)Global.dbbases.get(selectedRow)+".jar";
             String sfull=(String)Global.dbbases_full_info.get(selectedRow);
             String nrows=(String)Global.dbbases_no_entries.get (selectedRow);
             statusBar.setText(sfull+"; words="+nrows+";  file:"+sfile); 
        }
    }
});





        menuBar.add(toolsMenu);
        helpMenu=buildHelpMenu();
        menuBar.add(helpMenu);

        setJMenuBar(menuBar);

        pack();




        /*

        WindowListener exitListener = new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                int confirm = JOptionPane.showOptionDialog(this,
                        "Are You Sure to Close jSlovo?",
                        "Exit Confirmation", JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE, null, null, null);
                if (confirm == JOptionPane.YES_OPTION) {
                    exitApplication(); // System.exit(0);
                }
            }
        };
        addWindowListener(exitListener);

        */
        if (Global.isEmbeded) setDefaultCloseOperation(DISPOSE_ON_CLOSE); 






    }//GEN-END:initComponents
   



// global exit  
 public  void exitApplication() {

       
      Dimension dim;
      Point pos;

      // store mainframe dimensions
      dim = getSize();     
      Options.setIntOption( "frame.width",  dim.width );
      Options.setIntOption( "frame.height", dim.height );
      pos = getLocation();
      Options.setIntOption( "frame.x", pos.x);
      Options.setIntOption( "frame.y", pos.y);
      StringBuilder sb = new StringBuilder();      
      // save dictionaries (only active) 
      for(int i=0;i<Global.dbbases.size();i++) { 
             if(Global.ActivateDic[i]==true)
                 sb.append(Global.dbbases.get(i)+";");
       }
      String sfav = sb.toString();
      if (sb != null) Options.setOption("dictionary.active", sfav);

 
      // localisation  
      Options.setOption( "user.locale",Global.LANGU);

      // fonts
      Options.setOption( "article.font.family",  Global.font_family );
      Options.setOption( "article.font.name",    Global.font_name  );
      Options.setOption( "article.font.style",   Global.font_style  );
      Options.setOption( "article.font.size",    Global.font_size );
      Options.setOption( "article.font.face",    Global.font_face );

      // GUI 
      Options.setIntOption( "gui.lookfeel", Global.Style);
    


  //      Color color=null;
  //      color = jAnswer.jArticle.getBackground();
  //      Global.background_color="#"+Integer.toHexString( color.getRGB() & 0x00ffffff );
        Options.setOption( "article.backg.color",  Global.background_color );


 //       color = jAnswer.jArticle.getForeground();;
 //       Global.color="#"+Integer.toHexString( color.getRGB() & 0x00ffffff );
        Options.setOption( "article.foreg.color",  Global.color );


      // save options 
      if (!Options.checkOption()) {

        JOptionPane dialog1 = new JOptionPane();

       String mesg =ResourceLoader.getDisplay("message.options"); 
       int ask=dialog1.showConfirmDialog(dialog1, mesg, 
             ResourceLoader.getDisplay("message.question"), 
              JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE, null ); 
       if (ask == JOptionPane.YES_OPTION) Options.save();
       if (ask == JOptionPane.NO_OPTION)  Options.reset(); 
       }

      setVisible(false);
      dispose();

      if (!Global.isEmbeded) System.exit(0);
    }
    



// set group to exact search  
     public void SetToExact() {
  

       bexact.setSelected(true);
       Global.SelectSubstring=false;
       Global.sCand.setInvisible();
 
       jSplitPane1.revalidate();

 //     jPanel2.setPreferredSize(new java.awt.Dimension(240, 200));

//      pack();

      Global.description="";
      Global.Cand.clear();
      Global.CandIndex.clear();
      Global.CandDic.clear();
      Global.CandTopIndex.clear();
      }



// results search
      public void SearchResult() {
    	  
    	  
    	boolean special=false;
  		if (Global.Word.equalsIgnoreCase("###") ) special=true;
    	  
  		 String s="";
         for(int i=0;i<Global.dbbases.size();i++)
        {
        
             if(Global.ActivateDic[i]==true)
             {

                 
                 if ( special==true) {
                 s=s+"file="+Global.dbbases.get(i)+".jdic<br>";
                 s=s+"short name  ="+Global.dbbases_alias.get(i)+"<br>";
                 s=s+"full  name  ="+Global.dbbases_full_info.get(i)+"<br>";
                 s=s+"info        ="+Global.dbbases_info.get(i)+"<br>";
                 s=s+"definitions ="+Global.dbbases_no_entries.get(i)+"<br>";
                 s=s+"<p>";                
                 }
                 
               //   Log.i("ASlovoActivity", "Active dictionary: " + item);

             }
        }
  		

 		// show info about the dictionaries and exit
 		if ( special == true) {
 			 Global.Message=ResourceLoader.getDisplay("message.searching")+" '"+Global.Word+"'";
 			// statusBar.setText(Global.Message); 
 			Global.allDescription=s;
 			jAnswer.showText(s);
 			return;
 		}
        
         
         
         
         
         
         
         
         
         
         
         
  		
  		
  		
  		
  		
  		
  		
  		
  		
  		
  		
  		
  		
 
       if (Global.Word.length()>0) { 
       Global.Message=ResourceLoader.getDisplay("message.searching")+" '"+Global.Word+"'";
       statusBar.setText(Global.Message);
       Global.allDescription=""; 
       }

 

       if (Global.SelectSubstring == false && Global.Word.length()>0) {
          sw.start();
          jAnswer.Get();           // get answer
          sw.stop(); 
          Global.Message=ResourceLoader.getDisplay("message.dbtime")+Long.toString(sw.getTime())+ " ms";

        statusBar.setText(Global.Message); 
        // sw.start();
        // jAnswer.HTMLfile();        // create HTML file
        // jAnswerLinks.makeLinks();
        // sw.stop();
        // Global.Message=Global.Message+ "  Format="+Long.toString(sw.getTime())+" ms";  
       // statusBar.setText(Global.Message);
     }

      // not exact
      if (Global.SelectSubstring == true && Global.Word.length()>0) {

         Global.Cand.clear();
         Global.sCand.list.setListData( Global.Cand.toArray());

          sw.start();
          jAnswer.Get();           // get answer
          sw.stop();
         // jAnswer.HTMLfile();         // create HTML file
         // if found

          if (Global.Cand.size()>0) {

//          for (int i=0; i<Global.Cand.size();  i++) {
//          String ss=(String)Global.Cand.elementAt(i);
//          System.out.println("this word="+i+" "+ss); 
//          }
//          variableModel.setListData( Global.Cand );

           Global.sCand.list.setListData( Global.Cand.toArray() );

           Global.Message=ResourceLoader.getDisplay("message.found")+" "+
                 Integer.toString(Global.Cand.size())+" "+ResourceLoader.getDisplay("message.words");
           Global.Message=Global.Message+ "  "+ResourceLoader.getDisplay("message.dbtime")
                                              +Long.toString(sw.getTime())+" ms";
           statusBar.setText(Global.Message);
         //  jAnswerLinks.makeLinks();
         } else {
           statusBar.setText(ResourceLoader.getDisplay("message.nofound"));
           }

     }

 }




// make HTML lins in thread ..
 class Thread1 implements Runnable {

 Thread t;
 Thread1(String s1) {
       t= new Thread (this,s1);
       t.start();
 } 
   public void run() {
        jAnswerLinks.makeLinks();
   }
 } // end Thread1  
//-------------------------------------



// making titles of dictionaries  and booting databases
public class Thread2 implements Runnable {
 Thread t;
 Thread2(String s1) {
       t= new Thread (this,s1);
       t.start();
 }
   public void run() {
	   
	   Global.getDictInfo();


           // check which one are active
     String activeDB =  Options.getOption("dictionary.active");
     String[] a = activeDB.split(";");

      for(int i=0;i<Global.dbbases.size();i++) {
                 Global.ActivateDic[i] = false;
                 boolean active=false;
                 for (int j = 0; j < a.length; j++) {
                    if (a[j].length() > 1) {
                       if (Global.dbbases.get(i).equals(a[j])) active=true;
                 }
                 }
                Global.ActivateDic[i] = active;
                // System.out.println(active);
      }

      jPanel2.addDatabases();

       for (int i=0;i<Global.dbbases.size(); i++) {
                   jPanel2.jDicSelect.setValueAt(new String( Global.dbbases_alias.get(i)),i,1);
                   //Global.ActivateDic[i]=false;
           }


 
           
 } // end Thread2
}



// making titles of dictionaries  and booting databases
public class Thread3 implements Runnable {
 Thread t;
 Thread3(String s1) {
       t= new Thread (this,s1);
       t.start();
 }

   public void run() {
      SearchResult();
   }
 } // end Thread3



// timer task: load RMC
      ActionListener taskUNICODE = new ActionListener() {
            boolean alreadyDisposed = false;
            public void actionPerformed(ActionEvent ermc) {
      //    jPanel2.SearchField.setText(Global.UnicodeChar);

          if (!tmpUnicodeChar.equals(Global.UnicodeChar) ) {  
            try {
            jPanel2.SearchField.getDocument().insertString(jPanel2.SearchField.getCaretPosition(),
             Global.UnicodeChar,null);
            tmpUnicodeChar=Global.UnicodeChar;
            }  catch (Exception e) { System.out.println( "Cannot set character!" ); }; 
          }

      }; 
     }; 
    



// timer task: update GUI
      ActionListener taskUPDATE = new ActionListener() {
            boolean alreadyDisposed = false;
            public void actionPerformed(ActionEvent ermc) {

             // initial GUI style;
             if (Global.Style != StyleTMP) {
                StyleTMP=Global.Style;
	        SetGuiStyle(); 
              }

             }; }; 


	          // results search
      public void SetButtonMenu() {
    
      Sty0.setSelected(false); 	     
      if (Global.Style == 0)  Sty0.setSelected(true);       
      Sty1.setSelected(false); 
      if (Global.Style == 1)  Sty1.setSelected(true); 
      Sty2.setSelected(false); 
      if (Global.Style == 2)  Sty2.setSelected(true); 
      Sty3.setSelected(false); 
      if (Global.Style == 3)  Sty3.setSelected(true); 
   }// SetButtonMenu	     
	     


                 // results search
      public void SetButtonLocal() {

      Lang0.setSelected(false);
      if (Global.LANGU.equals("en"))  Lang0.setSelected(true);
      Lang1.setSelected(false);
      if (Global.LANGU.equals("ru"))  Lang1.setSelected(true);

   }// SetButtonMenu
	     

 // show info 
      public void ShowInfo( String s) {

      JOptionPane dialog = new JOptionPane();

      String mesg = "<html><b>"+s+"</b></html>"; 
      int ask=dialog.showConfirmDialog(dialog, mesg,
      "Information", JOptionPane.CANCEL_OPTION,
      JOptionPane.INFORMATION_MESSAGE, null );

      if (ask == JOptionPane.YES_OPTION) { Options.save(); System.exit(0);} 
  //    if (ask == JOptionPane.CANCEL_OPTION ) 


      }
	     
	     // results search
      public void SetGuiStyle() {


        // System.out.println(Global.Style);

    
	if (Global.Style == 0) {
         try {
          UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
         SwingUtilities.updateComponentTreeUI(Application.this);
         Application.this.pack();
           }
                catch (Exception exc) {
               //  SetIni.ShowStatus="Could not load LookAndFeel";
                }
                }


                if (Global.Style == 1) {
                try {
                UIManager.setLookAndFeel(Global.metalClassName);
                SwingUtilities.updateComponentTreeUI(Application.this);
                Application.this.pack();
                }
                catch (Exception exc) {
             //   SetIni.ShowStatus="Could not load LookAndFeel";
                }
                }

                if (Global.Style == 2 || Global.Style == 4) {
                try {



                    try {
                       for (LookAndFeelInfo info : UIManager.getInstalledLookAndFeels()) {
                           if ("Nimbus".equals(info.getName())) {
                                   UIManager.setLookAndFeel(info.getClassName());
                                   break;
                           }
                       }
                    } catch (Exception e) {
                    // If Nimbus is not available, you can set the GUI to another look and feel.
                     e.printStackTrace();
                    }




                SwingUtilities.updateComponentTreeUI(Application.this);
                Application.this.pack();
                }
                catch (Exception exc) {
           //     SetIni.ShowStatus="Could not load LookAndFeel";
                }
                }

                if (Global.Style == 3) {
                try {
                UIManager.setLookAndFeel(Global.windowsClassName);
                SwingUtilities.updateComponentTreeUI(Application.this);
                Application.this.pack();
                }
                catch (Exception exc) {
            //    SetIni.ShowStatus="Could not load LookAndFeel";
                }
                }

	      
      } // end set GUI style


  // set look
  public void setLook(String look) {

    try {
     UIManager.setLookAndFeel(Global.windowsClassName);
     SwingUtilities.updateComponentTreeUI(Application.this);
      Application.this.pack();
   } catch (Exception exc) { };

}


// show article from the index 
public void ShowArticleFromIndex(int index) {
               Object tmp1=Global.Cand.get(index);
               jTabs.setSelectedIndex(0);
               jPanel2.SearchField.setText((String)tmp1);
            // show this candidate as article
               jAnswer.DisplayCandidates(index);
 }



// save HTML file 
public void SaveFileHTML() {
     JFileChooser fc = new JFileChooser();
     fc.setApproveButtonText( ResourceLoader.getCommand("button.save") ); 
     int returnVal = fc.showOpenDialog(Application.this);
     if (returnVal == JFileChooser.APPROVE_OPTION) {
     String currFileName = fc.getSelectedFile().getPath();
     if (currFileName.length()>0) jAnswer.HTMLfile( currFileName );
    }
}


// start timer to set characters from keyboard
public void StartUnicodeTimer() {
         timer1.start();
}



public void FontSelect() {

           Font f = FontChooser.showDialog(Application.this,
                                    "Choose font",
                                    jAnswer.jArticle.getFont());
           if (f != null) {

           jAnswer.jArticle.setFont(f);
           Global.font_family=f.getFamily();
           Global.font_size=Integer.toString( f.getSize() );

           Global.font_face="normal";
           if (f.isBold()) Global.font_face="bold";
           if (f.isItalic() ) Global.font_face="italic";
           if (f.isBold() & f.isItalic() ) {
             Global.font_face="bold";
             Global.font_style="italic";
           }

           jAnswer.Style(); // set colors
           jAnswer.jArticle.repaint();

           }
          // contentPane.repaint();
 }



public void ForegroundSelect() {


        Color color = JColorChooser.showDialog(Application.this,
                       "Foreground Color",jAnswer.jArticle.getForeground());
         if (color != null) {
         jAnswer.jArticle.setForeground(color);
         Global.color="#"+Integer.toHexString( color.getRGB() & 0x00ffffff );
//         System.out.println("Color: "+color.toString());
//         System.out.println(Global.foreground_color);
         jAnswer.Style(); // set colors
         }
 

        jAnswer.jArticle.repaint();
 } 






// select background 
public void BackgroundSelect() {

         Color color = JColorChooser.showDialog(Application.this,
                       "Background Color",jAnswer.jArticle.getBackground());
         if (color != null) {
         Global.background_color="#"+Integer.toHexString( color.getRGB() & 0x00ffffff );
//         jAnswer.jArticle.setBackground(color);
         jAnswer.Style(); // set colors
         SearchResult();  // to reset the color
         }
           jAnswer.jArticle.repaint();
 }




// start search 
public void Search() {
        jTabs.setSelectedIndex(0);
        String ss =ResourceLoader.getDisplay("message.searching");
        jAnswer.jArticle.setText(ss+"= "+Global.Word+" .. wait!");
        new Thread3("Searching for a word");
        System.gc();
}



private static JMenuItem makeItem ( String token, boolean enabled )
   {
      JMenuItem   item;

      item = new JMenuItem( ResourceLoader.getCommand( token ) );
      item.setActionCommand( token );
      item.setEnabled( enabled );
      item.addActionListener( Global.mainActionListener );
      return item;
   }








// build file Menu  
private static JMenu buildFileMenu()
   {
      JMenu    menu;
      menu  = new JMenu( ResourceLoader.getCommand("menu.file") );
      menu.addMenuListener( mListener );
      menu.setEnabled( true );

      saveAsMenuItem  = makeItem( "menu.file.save", true );
      menu.add(saveAsMenuItem);

      menu.addSeparator();

      exitMenuItem = makeItem( "menu.file.exit", true );
      menu.add(exitMenuItem);

      return menu;
   }


// build file Menu
private static JMenu buildHelpMenu()
   {
      JMenu    menu;
      menu  = new JMenu( ResourceLoader.getCommand("menu.help") );
      menu.addMenuListener( mListener );
      menu.setEnabled( true );


      contentsMenuItem = makeItem( "menu.help.docs", true );
      menu.add(contentsMenuItem);

      aboutMenuItem = makeItem( "menu.help.about", true );
      menu.add(aboutMenuItem);

      return menu;
   }




  private static class MListener implements MenuListener
   {
      public void menuCanceled ( MenuEvent e )
      {
      }
      public void menuDeselected ( MenuEvent e )
      {
      }
      public void menuSelected ( MenuEvent e )
      {
         ActionHandler.resetIdleTime();
      }
   }










    
}
