// * This code is licensed under:
// * JSlovo License, Version 1.0
// * - for license details see http://jslovo.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

 
package jslovo.ui;


import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;



class CustomCellRenderer extends  JLabel 
                   implements ListCellRenderer { 

 private ImageIcon image[];
 final static ImageIcon longIcon = new ImageIcon("long.gif");
 final static ImageIcon shortIcon = new ImageIcon("short.gif");


 // change defaults for JList
 public CustomCellRenderer()
 {
  setOpaque(true);

  // Pre-load the graphics images to save time
  image = new ImageIcon[Global.Nmax];
  for (int i=0; i<Global.Nmax;  i++) {
   image[i] = new ImageIcon( "circles.gif" );
  }


 }

 public Component getListCellRendererComponent(
   JList list, Object value, int index,
   boolean isSelected, boolean cellHasFocus )


 {
  // Display the text for this item
  String s = value.toString();
         setText(s);
         setIcon((s.length() > 10) ? longIcon : shortIcon);


  // Draw the correct colors and font
  if( isSelected )
  {
   // Set the color and font for a selected item
   setBackground( Color.blue );
   setForeground( Color.white );
   setFont( new Font( "Arial", Font.BOLD, 14 ) );
  }
  else
  {
   // Set the color and font for an unselected item
   setBackground( Color.white );
   setForeground( Color.black );
   setFont( new Font( "Arial", Font.BOLD, 14 ) );
  }

  return this;
 }
}


