// * This code is licensed under:
// * JSlovo License, Version 1.0
// * - for license details see http://jslovo.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by the S.Chekanov (chekanov@sdf.lonestar.org). 
// * All rights reserved.

package jslovo.ui;

import java.io.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;

import jslovo.util.*;

import jslovo.jdatabase.dbslovoSearch;

public class PanelAnswer extends JScrollPane {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final String newline = "\n";
	public JTextPane jArticle;
	private StyledDocument doc;
	private Style style;
	private HTMLEditorKit htmlEditor;
	private StyleSheet ssh;

	public PanelAnswer() {

      jArticle = new JTextPane(){
      public void paintComponent(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,
          RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
        g2.setRenderingHint(RenderingHints.KEY_RENDERING,
          RenderingHints.VALUE_RENDER_QUALITY);
        super.paintComponent(g2);
      } }; 

		htmlEditor = new HTMLEditorKit();
		jArticle.setEditorKit(htmlEditor);

		doc = (StyledDocument) jArticle.getDocument();
		// style = doc.addStyle("StyleName", null);
		style = doc.getStyle("text/html");

		// jArticle.setContentType("text/html"); // show as HTML
		this.getViewport().add(jArticle);
		jArticle.setEditable(false);
		setMyFont();

		String s1 = ResourceLoader.getDisplay("ui.welcome1") + "<hr>";
		String s2 = ResourceLoader.getDisplay("ui.welcome2") + Global.DBdir;
		jArticle.setText(s1 + s2);
		jArticle.setCaretPosition(0);

	}


    public void paintComponent(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,
          RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
        g2.setRenderingHint(RenderingHints.KEY_RENDERING,
          RenderingHints.VALUE_RENDER_QUALITY);
        super.paintComponent(g2);
    }


	// set fonts
	public void setMyFont() {

		int iff = Font.PLAIN;
		if (Global.font_face.equals("plain"))
			iff = Font.PLAIN;
		if (Global.font_face.equals("bold"))
			iff = Font.BOLD;
		if (Global.font_face.equals("italic"))
			iff = Font.ITALIC;
		int isize = Integer.parseInt(Global.font_size);
		// System.out.println(Global.color);
		// System.out.println(Global.background_color);

		Font f = new Font(Global.font_family, iff, isize);
		jArticle.setFont(f);
	}// end set fonts

	// get answer
	public void Get() {

		// search
		Global.description = "";
		Global.Cand.clear();
		Global.CandDic.clear();
		Global.CandDicAlias.clear();
		Global.CandIndex.clear();
		Global.CandTopIndex.clear();
		Global.dbbases_notfound.clear();
		int NoDB = 0;

		for (int i = 0; i < Global.dbbases.size(); i++) {
			if (Global.ActivateDic[i] == true) { // only active dictionary
				// get answer
				ReadDB.query(i, Global.SelectSubstring);
				NoDB++;

				// now vectors are ready
				if (Global.SelectSubstring == false) { // exact answer
					addCombine();
				}

			} // active dictionary
		} // for

		// show all

		if (Global.description.length() < 1) {
			jArticle.setText("Did you select a database?");
		}

		if (Global.SelectSubstring == false && Global.dbbases_notfound.size() > 0) {

			String footer = newline
					+ "<p><hr> <FONT COLOR=\"#FF6633\"> <b>Not found: </b></FONT><br>";
			jArticle.setText(Global.description + footer);

			try {
				for (int i = 0; i < Global.dbbases_notfound.size(); i++) {
					String ss = (String) Global.dbbases_notfound.get(i);
					doc.insertString(doc.getLength(), ss + newline, style);
				}
			} catch (Exception ignore) {
			}
		} else {
			String footer = newline
					+ "<p> <hr><div style=\"margin-left:20px;text-align:right;\"><FONT COLOR=\"#FFCC33\"><b>JSlovo 2.0</b></FONT></div>";
			jArticle.setText(Global.description + footer);
		}

		jArticle.setCaretPosition(0);

	} // end
	
	
	
	
	
	
	/**
	 * Just show  atext
	 * @param text
	 */
	public void showText(String text) {

		
	   jArticle.setText(text);
		

		jArticle.setCaretPosition(0);

	} // end
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

	// show answer
	public void addCombine() {

		// System.out.println("Call to display.."+Global.currentDic);

		if (Global.descriptionTMP.length() > 1) {
			String s1 = "<H2> " + "<FONT COLOR=\"#008000\"> "
					+ Global.currentDic + " </FONT> </SPAN>";

			String s2 = " <FONT COLOR=\"#000080\"> " + Global.word
					+ " </FONT> </H2> \n";
			Global.description = Global.description + s1 + s2
					+ Global.descriptionTMP;

			Format.Correct(); // correct output

			Global.allDescription = Global.allDescription + Global.description;

			// if nothing is fond
		} else {
			Global.dbbases_notfound.add(Global.currentDic);
			// Global.descriptionTMP =
			// "<H2> <FONT COLOR=\"#008000\"> "+Global.currentDic+" </FONT>"+
			// " <FONT COLOR=\"#000080\"> "+Global.word+" not found </FONT> </H2> \n";
			//
			// Global.description=Global.description+Global.descriptionTMP;
		}
		// Append to document

	}

	// show candidates
	public void DisplayCandidates(int index) {

		String fileDic = (String) Global.CandDic.get(index);
		Global.currentDic = (String) Global.CandDicAlias.get(index);
		Global.word = (String) Global.Cand.get(index);

		// set current dic
		String sreal = (String) Global.CandIndex.get(index);
		String stop = (String) Global.CandTopIndex.get(index);
		stop = stop.trim();

		long ifound = -1;
		if (sreal.trim().length() > 0) {
			try {
				ifound = Long.parseLong(sreal.trim());
			} catch (NumberFormatException nfe) {
				nfe.printStackTrace();
			}
		}

		// System.out.println("OUTPUT: Index="+index+"  "+
		// Global.currentDic+" "+stop+" "+ifound+" "+Global.word);

		// get all variables
		Global.description = dbslovoSearch.FindFromIndex(Global.word, fileDic,
				stop, ifound);

		if (Global.description.length() > 0) {
			String s1 = "<H2>" + "<FONT COLOR=\"#008000\">" + Global.currentDic
					+ "</FONT></SPAN>";

			String s2 = " <FONT COLOR=\"#000080\">:  " + Global.word
					+ "</FONT></H2> \n";
			Global.allDescription = s1 + s2 + Global.description;
			Format.Correct(); // correct output
			jArticle.setText(Global.allDescription);
			jArticle.setCaretPosition(0);
			// if nothing is fond
		} else {
			Global.description = "<H3> <FONT COLOR=\"#008000\">"
					+ Global.currentDic + "</FONT>"
					+ " <FONT COLOR=\"#000080\"> " + Global.word
					+ " cannot be found</FONT> </H3> \n";
			jArticle.setText(Global.description);
			jArticle.setCaretPosition(0);
		}

	} // end

	public void HTMLfile(String sf) {
		// create report
		try {
			FileOutputStream tmpc = new FileOutputStream(sf);
			PrintStream tmpcheck = new PrintStream(tmpc);
			tmpcheck.print(jArticle.getText());
			tmpcheck.close();
		} catch (IOException e) {
			System.out.println("Error creating report.html" + e);
		}

	} // end

	// 
	public void Style() {

		ssh = htmlEditor.getStyleSheet();

		String f1 = "font-family: " + Global.font_family + "; ";
		String f2 = "font-weight: " + Global.font_face + "; ";
		String f3 = "font-size: " + Global.font_size + " pt ; ";
		String f4 = "background-color: " + Global.background_color + "; ";
		String f5 = "color: " + Global.color + "; ";
		String f6 = "font-style: " + Global.font_style + "; ";

		ssh.addRule("body { " + f1 + f2 + f3 + f4 + f5 + f6 + "} ");
	}

} // end main class

